<template>
  <button
    @click="onClick"
    v-bind="attrs"
    type="button"
    :disabled="disabled || loading"
    class="btn btn-success"
  >
    <span
      v-if="loading"
      class="spinner-border spinner-border-sm"
      role="status"
      aria-hidden="true"
    ></span>
    <span class="me-1" v-if="slots.icon && !loading">
      <slot name="icon"> </slot>
    </span>
    <slot v-if="!loading"></slot>
  </button>
</template>

<script setup>
import { defineEmits, useAttrs, useSlots } from "vue";
import { debounce } from "@/components/Button/debounce";

const attrs = useAttrs();

const slots = useSlots();

const emit = defineEmits({
  click: null,
});

const props = defineProps({
  delay: { type: Number, required: false },
  loading: { type: Boolean, required: false, default: false },
  disabled: { type: Boolean, required: false, default: false },
});

const clickHandler = (event) => {
  if (props.loading || props.disabled) return;
  emit("click", event);
};

// const

const onClick =
  props.delay !== undefined
    ? debounce(clickHandler, props.delay)
    : clickHandler;
</script>
